Attribute VB_Name = "modRotatePicture"
'**********************************************
'* Module to print rotated picture on screen: *
'**********************************************

Option Explicit

Private Type POINTAPI

  x As Long
  y As Long
  
End Type

Private Const PI As Double = 3.14159265358979

Private Declare Function CreatePolygonRgn Lib "gdi32" (lpPoint As POINTAPI, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function PlgBlt Lib "gdi32" (ByVal hdcDest As Long, lpPoint As POINTAPI, ByVal hdcSrc As Long, ByVal nXSrc As Long, ByVal nYSrc As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hbmMask As Long, ByVal xMask As Long, ByVal yMask As Long) As Long

Public Sub PrintRotatedPicture(ByRef oImageSrc As Image, ByRef oPictureDst As PictureBox, ByVal iRotation As Integer)

  On Error Resume Next
  
  Dim lWidthSrc  As Long
  Dim lHeightSrc As Long
  Dim lWidthDst  As Long
  Dim lHeightDst As Long
  Dim hRgn       As Long
  Dim pt()       As POINTAPI
  Dim i          As Integer
  Dim TX         As Integer 'X-translation
  Dim TY         As Integer 'Y-translation
  
  iRotation = iRotation Mod 360
  If iRotation < 0 Then iRotation = iRotation + 360 '0 <= iRotation < 360
  lWidthSrc = oImageSrc.Width
  lHeightSrc = oImageSrc.Height
  
  If (iRotation < 90) Or (iRotation < 270 And iRotation >= 180) Then
  
    If lWidthSrc > lHeightSrc * Sin((iRotation Mod 90) * PI / 180) + lWidthSrc * Cos((iRotation Mod 90) * PI / 180) Then
    
      lWidthDst = lWidthSrc
      TX = RoundUp((lWidthSrc - (lHeightSrc * Sin((iRotation Mod 90) * PI / 180) + lWidthSrc * Cos((iRotation Mod 90) * PI / 180))) / 2)
      
    Else
    
      lWidthDst = RoundUp(lHeightSrc * Sin((iRotation Mod 90) * PI / 180) + lWidthSrc * Cos((iRotation Mod 90) * PI / 180))
      
    End If
    
    If lHeightSrc > lHeightSrc * Cos((iRotation Mod 90) * PI / 180) + lWidthSrc * Sin((iRotation Mod 90) * PI / 180) Then
    
      lHeightDst = lHeightSrc
      TY = RoundUp((lHeightSrc - (lHeightSrc * Cos((iRotation Mod 90) * PI / 180) + lWidthSrc * Sin((iRotation Mod 90) * PI / 180))) / 2)
      
    Else
    
      lHeightDst = RoundUp(lHeightSrc * Cos((iRotation Mod 90) * PI / 180) + lWidthSrc * Sin((iRotation Mod 90) * PI / 180))
      
    End If
    
  Else
  
    If lWidthSrc > lWidthSrc * Sin((iRotation Mod 90) * PI / 180) + lHeightSrc * Cos((iRotation Mod 90) * PI / 180) Then
    
      lWidthDst = lWidthSrc
      TX = RoundUp((lWidthSrc - (lWidthSrc * Sin((iRotation Mod 90) * PI / 180) + lHeightSrc * Cos((iRotation Mod 90) * PI / 180))) / 2)
      
    Else
    
      lWidthDst = RoundUp(lWidthSrc * Sin((iRotation Mod 90) * PI / 180) + lHeightSrc * Cos((iRotation Mod 90) * PI / 180))
      
    End If
    
    If lHeightSrc > lWidthSrc * Cos((iRotation Mod 90) * PI / 180) + lHeightSrc * Sin((iRotation Mod 90) * PI / 180) Then
    
      lHeightDst = lHeightSrc
      TY = RoundUp((lHeightSrc - (lWidthSrc * Cos((iRotation Mod 90) * PI / 180) + lHeightSrc * Sin((iRotation Mod 90) * PI / 180))) / 2)
      
    Else
    
      lHeightDst = RoundUp(lWidthSrc * Cos((iRotation Mod 90) * PI / 180) + lHeightSrc * Sin((iRotation Mod 90) * PI / 180))
      
    End If
    
  End If
  
  oPictureDst.Visible = False
  
  'Resize the destination picture box:
  
  oPictureDst.AutoRedraw = True
  oPictureDst.AutoSize = False
  oPictureDst.Cls
  oPictureDst.Width = lWidthDst
  oPictureDst.Height = lHeightDst
  
  'Rotate the picture box:
  
  If Not (oImageSrc Is Nothing) Then
  
    oPictureDst.PaintPicture oImageSrc.Picture, oPictureDst.ScaleLeft + (oPictureDst.ScaleWidth - lWidthSrc / Screen.TwipsPerPixelX) / 2 - 1, oPictureDst.ScaleTop + (oPictureDst.ScaleHeight - lHeightSrc / Screen.TwipsPerPixelY) / 2 - 1, RoundUp(lWidthSrc / Screen.TwipsPerPixelX) + 2, RoundUp(lHeightSrc / Screen.TwipsPerPixelY) + 2
    ReDim pt(2)
    pt(0).x = 0
    pt(0).y = 0
    pt(1).x = oPictureDst.ScaleWidth
    pt(1).y = 0
    pt(2).x = 0
    pt(2).y = oPictureDst.ScaleHeight
    
    For i = 0 To 2
    
      pt(i) = RotateP(oPictureDst.ScaleWidth / 2, oPictureDst.ScaleHeight / 2, pt(i), -iRotation * PI / 180)
      
    Next
    
    PlgBlt oPictureDst.hDC, pt(0), oPictureDst.hDC, 0, 0, oPictureDst.ScaleWidth, oPictureDst.ScaleHeight, ByVal 0&, ByVal 0&, ByVal 0&
    oPictureDst.Refresh
    
  End If
  
  'Set up 4 (+ 1) points:
  
  ReDim pt(4)
  
  pt(0).x = 0 + TX / Screen.TwipsPerPixelX
  pt(1).y = 0 + TY / Screen.TwipsPerPixelY
  
  If (iRotation >= 0 And iRotation < 90) Or (iRotation >= 180 And iRotation < 270) Then
  
    pt(0).y = (lWidthSrc * Sin((iRotation Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
    pt(1).x = (lWidthSrc * Cos((iRotation Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
    pt(2).x = (lHeightSrc * Sin((iRotation Mod 90) * PI / 180) + lWidthSrc * Cos((iRotation Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
    pt(2).y = (lHeightSrc * Cos((iRotation Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
    pt(3).x = (lHeightSrc * Sin((iRotation Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
    pt(3).y = (lHeightSrc * Cos((iRotation Mod 90) * PI / 180) + lWidthSrc * Sin((iRotation Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
    
  ElseIf (iRotation >= 90 And iRotation < 180) Or (iRotation >= 270 And iRotation < 360) Then
  
    pt(0).y = (lHeightSrc * Sin((iRotation Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
    pt(1).x = (lHeightSrc * Cos((iRotation Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
    pt(2).x = (lWidthSrc * Sin((iRotation Mod 90) * PI / 180) + lHeightSrc * Cos((iRotation Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
    pt(2).y = (lWidthSrc * Cos((iRotation Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
    pt(3).x = (lWidthSrc * Sin((iRotation Mod 90) * PI / 180) + TX) / Screen.TwipsPerPixelX
    pt(3).y = (lWidthSrc * Cos((iRotation Mod 90) * PI / 180) + lHeightSrc * Sin((iRotation Mod 90) * PI / 180) + TY) / Screen.TwipsPerPixelY
    
  End If
  
  pt(4).x = pt(0).x
  pt(4).y = pt(0).y
  
  'Create a region from the points:
  
  hRgn = CreatePolygonRgn(pt(0), (UBound(pt) + 1), 2)
  SetWindowRgn oPictureDst.hWnd, hRgn, True
  DeleteObject hRgn
  
  If Left(oImageSrc.Tag, 1) = "P" Then 'Polygonal rotation
  
  ' X' = X * cos + Y * sin + O_TX
  ' Y' = Y * cos - X * sin + O_TY
  
    Dim iPoints As Integer
    Dim sPoints As String
    Dim Ix()    As Long
    Dim Iy()    As Long
    Dim lMaxIx  As Long
    Dim lMaxIy  As Long
    Dim O_TX    As Long
    Dim O_TY    As Long
    
    iPoints = CInt(mid(oImageSrc.Tag, 2, InStr(oImageSrc.Tag, ";") - 2))
    sPoints = mid(oImageSrc.Tag, InStr(oImageSrc.Tag, ";") + 1)
    ReDim Ix(iPoints - 1)
    ReDim Iy(iPoints - 1)
    
    For i = 0 To iPoints - 1
    
      Ix(i) = CLng(Left(sPoints, InStr(sPoints, ",") - 1))
      Iy(i) = CLng(mid(sPoints, InStr(sPoints, ",") + 1, InStr(sPoints, " ") - InStr(sPoints, ",") - 1))
      sPoints = mid(sPoints, InStr(sPoints, " ") + 1)
      
    Next i
    
    lMaxIx = MaxArr(Ix)
    lMaxIy = MaxArr(Iy)
    
    If (iRotation >= 0 And iRotation < 90) Then
    
      O_TX = pt(0).x
      O_TY = pt(0).y
      
    ElseIf (iRotation >= 270 And iRotation < 360) Then
    
      O_TX = pt(1).x
      O_TY = pt(1).y
      
    ElseIf (iRotation >= 180 And iRotation < 270) Then
    
      O_TX = pt(2).x
      O_TY = pt(2).y
      
    ElseIf (iRotation >= 90 And iRotation < 180) Then
    
      O_TX = pt(3).x
      O_TY = pt(3).y
      
    End If
    
    ReDim pt(iPoints - 1)
    
    For i = 0 To iPoints - 1
    
      pt(i).x = Ix(i) / lMaxIx * oImageSrc.Width / iTwX * Cos(iRotation * PI / 180) + Iy(i) / lMaxIy * oImageSrc.Height / iTwY * Sin(iRotation * PI / 180) + O_TX
      pt(i).y = Iy(i) / lMaxIy * oImageSrc.Height / iTwY * Cos(iRotation * PI / 180) - Ix(i) / lMaxIx * oImageSrc.Width / iTwX * Sin(iRotation * PI / 180) + O_TY
      
    Next i
    
    hRgn = CreatePolygonRgn(pt(0), (UBound(pt) + 1), 2)
    SetWindowRgn oPictureDst.hWnd, hRgn, True
    DeleteObject hRgn
    ReDim Ix(0)
    ReDim Iy(0)
    
  End If
  
  hRgn = CreatePolygonRgn(pt(0), (UBound(pt) + 1), 2)
  SetWindowRgn oPictureDst.hWnd, hRgn, True
  DeleteObject hRgn
  ReDim pt(0)
  oPictureDst.ZOrder 0
  oPictureDst.Visible = True
  
End Sub

Private Function RotateP(ByRef x As Long, ByRef y As Long, ByRef Point As POINTAPI, Angle As Double) As POINTAPI

  On Error Resume Next
  
  Dim Tmp1 As Double
  Dim Tmp2 As Double
  
  Tmp1 = Point.x - x
  Tmp2 = Point.y - y
  Point.x = Tmp1 * Cos(Angle) - Tmp2 * Sin(Angle)
  Point.y = Tmp1 * Sin(Angle) + Tmp2 * Cos(Angle)
  Point.x = Point.x + x
  Point.y = Point.y + y
  RotateP = Point
  
End Function

Public Function RoundUp(ByVal Value As Double) As Long

  On Error Resume Next
  
  If CLng(Value) = Value Then
  
    RoundUp = Value
    
  Else
  
    RoundUp = CLng(Value) + 1
    
  End If
  
End Function
